/*
* Implements simple producer/consumer thread pair to cause load on the CPU.
* 
* Used in benchmarking the CAN gateway.
*
* Co-opted from http://support.dce.felk.cvut.cz/pos/cv3/src/semaphore.html. 
*/
#ifndef __CPU_LOAD_H_
#define __CPU_LOAD_H_


/*
* This function starts threads loading the CPU and creates associated semaphores. 
* 
* Has a guard to prevent starting again, before it was stopped.
*
* No error handling currently, only tries to report errors.
*
* 0 if successfull, 1 otherwise.
*/
int start_thread_load();

/*
* This function stops threads loading the CPU and destroys associated semaphores. 
*
* Has a guard against attempting to stop the threads if they are not running.
* 
* No error handling currently, only tries to report errors.
*
* 0 if successfull, 1 otherwise.
*/
int end_thread_load();

#endif

